------------------------------------------------------
-- Beispielskript zur SNEK 6 im April 2018 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Installation Beispieldatenbank SNEK 6
------------------------------------------------------

USE SNEK;
GO

-- Rechtevergabe per Systemrollen
ALTER ROLE db_datareader ADD MEMBER Hoppenstett;
ALTER ROLE db_datareader ADD MEMBER Kallaman;
ALTER ROLE db_datareader ADD MEMBER Lebhausen;
ALTER ROLE db_datawriter ADD MEMBER Hoppenstett;
ALTER ROLE db_datawriter ADD MEMBER Kallaman;
ALTER ROLE db_datawriter ADD MEMBER Lebhausen;
GO


-- Verweigern von Rechten fr Kallaman und Lebhausen
DENY SELECT, INSERT, UPDATE, DELETE ON Personal.Mitarbeiter TO Kallaman;
DENY SELECT, INSERT, UPDATE, DELETE ON Personal.Mitarbeiter TO Lebhausen;
GO


--> Hoppenstett darf lesen
EXECUTE As USER = 'Hoppenstett';
SELECT Nachname, Vorname, AktuellesGehalt FROM Personal.Mitarbeiter;
REVERT;
GO

--> Lebhausen darf nicht lesen
EXECUTE As USER = 'Lebhausen';
SELECT Nachname, Vorname, AktuellesGehalt FROM Personal.Mitarbeiter;
REVERT;
GO

-- Lebhausen in die Serverrolle sysadmin
EXEC sys.sp_addsrvrolemember 'WSSQL2017\Lebhausen', 'sysadmin';
GO

--> Lebhausen darf ALLES - auch lesen
EXECUTE As USER = 'Lebhausen';
SELECT Nachname, Vorname, AktuellesGehalt FROM Personal.Mitarbeiter;
REVERT;
GO

-- Lebhausen wieder raus aus Serverrolle sysadmin
EXEC sys.sp_dropsrvrolemember 'WSSQL2017\Lebhausen', 'sysadmin';
GO




