------------------------------------------------------
-- Beispielskript zur SNEK 6 im April 2018 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Installation Beispieldatenbank SNEK 6
------------------------------------------------------

USE SNEK;
GO


-- Spalten Email und Telefon mit eigener partieller Maskierung maskieren
ALTER TABLE dbo.Ansprechpartner
			ALTER COLUMN Email
			ADD MASKED WITH (FUNCTION = 'partial(2," -_- ", 2)');

ALTER TABLE dbo.Ansprechpartner
			ALTER COLUMN Telefon
			ADD MASKED WITH (FUNCTION = 'partial(3,"XXXXXXXX", 0)');
GO


-- Daten als DBO ausgeben
SELECT	Nachname, Vorname, Telefon, Email
FROM	dbo.Ansprechpartner;


-- Daten als Benutzer Kallaman ausgeben
EXECUTE AS USER = 'Kallaman';
SELECT	Nachname, Vorname, Telefon, Email
FROM	dbo.Ansprechpartner;
REVERT;


-- Maskierung fr Benutzer aufheben
GRANT UNMASK TO Kallaman;


-- Daten als Benutzer Kallaman ausgeben
EXECUTE AS USER = 'Kallaman';
SELECT	Nachname, Vorname, Telefon, Email
FROM	dbo.Ansprechpartner;
REVERT;


-- Daten als Benutzer Hoppenstett ausgeben
EXECUTE AS USER = 'Hoppenstett';
SELECT	Nachname, Vorname, Telefon, Email
FROM	dbo.Ansprechpartner;
REVERT;


