------------------------------------------------------
-- Beispielskript zur SNEK 6 im April 2018 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Installation Beispieldatenbank SNEK 6
------------------------------------------------------

USE SNEK;  
GO  


-- Zertifikat anlegen
-- DROP CERTIFICATE certSNEK;
CREATE CERTIFICATE certSNEK
	ENCRYPTION BY PASSWORD = 'MeinZertifikatFrDieSNEK2018!'
	WITH SUBJECT = 'Test-Zertifikat fr SNEK',
	EXPIRY_DATE = '20301231';


-- Zertifikat sichern
BACKUP CERTIFICATE certSNEK 
		TO FILE = 'D:\DSGVO und SQL Server\Zertifikate\certSNEK.cer';

-- Externes Zertifikat
--CREATE CERTIFICATE certSNEK   
--    FROM FILE = 'D:\DSGVO und SQL Server\Zertifikat SNEK.cer'   
--    WITH PRIVATE KEY (FILE = 'D:\DSGVO und SQL Server\Zertifikat SNEK.pvk',   
--    DECRYPTION BY PASSWORD = 'MeinZertifikatFrDieSNEK2018!');  
--GO  


-- Export-Tabelle anlegen
DROP TABLE IF EXISTS Personal.Datenexport;
CREATE TABLE Personal.Datenexport
(
	ExportID		INT				NOT NULL	IDENTITY	PRIMARY KEY,
	MitarbeiterID	VARBINARY(MAX)	NOT NULL,	
	Nachname		NVARCHAR(20)	NOT NULL,
	Vorname			NVARCHAR(10)	NOT NULL,
	Geburtsdatum	VARBINARY(MAX)	NOT NULL
);


-- Daten verschlsselt hinzufgen
INSERT INTO Personal.Datenexport(MitarbeiterID, Nachname, Vorname, Geburtsdatum) 
	 SELECT 
			ENCRYPTBYCERT(CERT_ID('certSNEK'), CAST(MitarbeiterID AS NVARCHAR(50))),  
			Nachname, 
			Vorname,
			ENCRYPTBYCERT(CERT_ID('certSNEK'), CAST(Geburtsdatum AS NVARCHAR(50)))
	 FROM	
			Personal.Mitarbeiter;


-- Daten ausgeben
SELECT	MitarbeiterID, Nachname, Vorname, Geburtsdatum FROM Personal.Datenexport;


-- Daten unverschlsselt ausgeben
SELECT	CONVERT(NVARCHAR(50), DECRYPTBYCERT(CERT_ID('certSNEK'), MitarbeiterID, N'MeinZertifikatFrDieSNEK2018!')) As MitarbeiterID, 
		Nachname,
		Vorname,
		CONVERT(NVARCHAR(50), DECRYPTBYCERT(CERT_ID('certSNEK'), Geburtsdatum, N'MeinZertifikatFrDieSNEK2018!')) As Geburtsdatum
FROM	Personal.Datenexport;
