------------------------------------------------------
-- Beispielskript zur SNEK 6 im April 2018 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Installation Beispieldatenbank SNEK 6
------------------------------------------------------

USE SNEK;
GO


-- Export-Tabelle anlegen
DROP TABLE IF EXISTS Personal.Datenexport;
CREATE TABLE Personal.Datenexport
(
	ExportID		INT				NOT NULL	IDENTITY	PRIMARY KEY,
	MitarbeiterID	VARBINARY(MAX)	NOT NULL,	
	Nachname		NVARCHAR(20)	NOT NULL,
	Vorname			NVARCHAR(10)	NOT NULL,
	Geburtsdatum	VARBINARY(MAX)	NOT NULL
);
GO


-- Zeichenfolge zur Verschlsselung definieren
DECLARE @Phrase NVARCHAR(128) = 'Nach der SNEK 2018 wird endlich verschlsselt!';


-- Daten verschlsselt hinzufgen
INSERT INTO Personal.Datenexport(MitarbeiterID, Nachname, Vorname, Geburtsdatum) 
	 SELECT 
			ENCRYPTBYPASSPHRASE(@Phrase, CAST(MitarbeiterID AS NVARCHAR(50))),  
			Nachname, 
			Vorname,
			ENCRYPTBYPASSPHRASE(@Phrase, CAST(Geburtsdatum AS NVARCHAR(50)))
	 FROM	
			Personal.Mitarbeiter;

-- Daten  ausgeben
SELECT	MitarbeiterID, Nachname, Vorname, Geburtsdatum FROM Personal.Datenexport;
GO


-- Daten unverschlsselt ausgeben
DECLARE @Phrase NVARCHAR(128)
SET @Phrase = 'Nach der SNEK 2018 wird endlich verschlsselt!';

SELECT	CONVERT(NVARCHAR(50), DECRYPTBYPASSPHRASE(@Phrase, MitarbeiterID)) As MitarbeiterID, 
		Nachname,
		Vorname,
		CONVERT(NVARCHAR(50), DECRYPTBYPASSPHRASE(@Phrase, Geburtsdatum)) As Geburtsdatum
FROM	Personal.Datenexport;